<template>
  <div>
    <br>
    <legend>Datos del encargo actual.</legend>
    <div class="row">
      <div class="col-md-4 form-group">
        <label class="control-label">
          Ente público
        </label><br>
        <el-select clearable class="select-default" name="ente" v-validate="modelValidations.ente" placeholder="Ente" v-model="model.ente_publico_id">
          <el-option v-for="option in entes" class="select-default" :value="option.id" :label="option.valor" :key="option.valor">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="ente.invalid">
          {{ getError('ente') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Nivel/Orden de Gobierno:
        </label>
        <br>
        <el-select clearable class="select-default" placeholder="Nivel" name="nivel_orden" v-validate="modelValidations.nivel_orden" v-model="model.nivel_gobierno_id">
          <el-option v-for="option in niveles" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="nivel_orden.invalid">
          {{ getError('nivel_orden') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Poder/Naturaleza jurídica
        </label><br>
        <el-select clearable class="select-default" placeholder="Poder" name="poder" v-validate="modelValidations.poder" v-model="model.poder_juridico_id">
          <el-option v-for="option in poderes" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="poder.invalid">
          {{ getError('poder') }}
        </small>
      </div>
    </div>

    <div class="row">
      <div class="col-md-8 form-group">
        <label class="control-label">
          Nombre del Empleo, Cargo o Comisión
        </label>
        <br>
        <input class="form-control" type="text" name="nombre_cargo" v-validate="modelValidations.nombre_cargo" v-model="model.empleo_cargo_comision" placeholder="Nombre del Cargo" />
        <small class="text-danger" v-show="nombre_cargo.invalid">
          {{ getError('nombre_cargo') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Contrato por honorarios.
        </label><br>
        <p-radio name="honorarios" v-validate="modelValidations.honorarios" v-model="model.contratado_honorarios" label="1">SI</p-radio>
        <p-radio name="honorarios" v-validate="modelValidations.honorarios" v-model="model.contratado_honorarios" label="2">NO</p-radio>

        <small class="text-danger" v-show="honorarios.invalid">
          {{ getError('honorarios') }}
        </small>
      </div>
    </div>

    <div class="row">
      <div class="col-md-4 form-group">
        <label class="control-label">
          Nivel
        </label>
        <br>
        <input class="form-control" type="text" name="nivel" v-validate="modelValidations.nivel" v-model="model.nivel_encargo" placeholder="Nivel" />
        <small class="text-danger" v-show="nivel.invalid">
          {{ getError('nivel') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Área
        </label>
        <br>
        <input class="form-control" type="text" name="area" v-validate="modelValidations.area" v-model="model.area_adscripcion" placeholder="Area de adscripción" />
        <small class="text-danger" v-show="area.invalid">
          {{ getError('area') }}
        </small>
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Fecha de toma de Posesión
        </label>
        <br>
        <el-date-picker name="toma_posesion" v-validate="modelValidations.toma_posesion" v-model="model.fecha_posesion" type="date" format="dd/MM/yyyy" placeholder="Selecciona">
        </el-date-picker>
        <small class="text-danger" v-show="toma_posesion.invalid">
          {{ getError('toma_posesion') }}
        </small>
      </div>
    </div>

    <domicilio v-model="n_domicilio" titulo="/Ubicación del Cargo"></domicilio>
    <br><br>
    <div class="row">
      <div class="col-md-2 form-group">
        <label class="control-label">
          Teléfono Laboral
        </label>
        <input class="form-control" type="text" name="curp" v-model="model.telefono_laboral_numero" placeholder="Teléfono Laboral" />
      </div>
      <div class="col-md-2 form-group">
        <label class="control-label">
          Ext
        </label>
        <input class="form-control" type="text" name="curp" v-model="model.telefono_laboral_extension" placeholder="Teléfono Laboral" />
      </div>
      <div class="col-md-4 form-group">
        <label class="control-label">
          Correo Electrónico
        </label>
        <input class="form-control" type="text" name="correo_laboral" v-validate="modelValidations.correo_laboral" v-model="model.correo_laboral" placeholder="Correo Laboral" />
        <small class="text-danger" v-show="correo_laboral.invalid">
          {{ getError('correo_laboral') }}
        </small>
      </div>

      <div class="col-md-4 form-group">
        <label class="control-label">
          Sector/Industria:
        </label>
        <el-select clearable class="select-default" placeholder="Sector" name="sector" v-validate="modelValidations.sector" v-model="model.sector_industria_id">
          <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="sector.invalid">
          {{ getError('sector') }}
        </small>
      </div>
    </div>

    <div class="row">
      <div class="col-sm-6 form-group">
        <label class="control-label">
          Funciones Principales:
        </label>
        <el-select clearable multiple class="select-primary" v-model="model.funcionesp" width="100%" name="funciones_p" v-validate="modelValidations.funciones_p" placeholder="Multiple Select">
          <el-option v-for="option in funciones" class="select-primary" :value="option.id" :label="option.valor" :key="option.codigo">
          </el-option>
        </el-select>
        <small class="text-danger" v-show="funciones_p.invalid">
          {{ getError('funciones_p') }}
        </small>
      </div>
    </div>
    <br>

    <div v-if="this.grupo != 3">
      <legend>Experiencia Laboral</legend>
      <br>
      <div v-if="add_item">
        <div class="row">
          <div class="col-md-6 form-group">
            <label class="control-label">
              Ámbito:
            </label>
            <br>
            <el-select clearable class="select-primary" v-model="modelexp.ambito_id" width="100%" name="ambitoexp" v-validate="modelExp.ambitoexp" placeholder="Ámbitos">
              <el-option v-for="option in ambitos" class="select-primary" :value="option.id" :label="option.valor" :key="option.codigo">
              </el-option>
            </el-select>
            <small class="text-danger" v-show="ambitoexp.invalid">
              {{ getError('ambitoexp') }}
            </small>

          </div>

        </div>
        <div class="row" v-if="modelexp.ambito_id == 1">
          <!-- Si es ámbito publico se piden los otros datos -->
          <div class="col-md-6 form-group">
            <label class="control-label">
              Nivel/Orden de Gobierno:
            </label>
            <br>
            <el-select clearable class="select-default" placeholder="Nivel" v-model="modelexp.nivel_gobierno_id">
              <el-option v-for="option in niveles" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
              </el-option>
            </el-select>
          </div>
          <div class="col-md-4 form-group">
            <label class="control-label">
              Poder/Naturaleza jurídica
            </label><br>
            <el-select clearable class="select-default" placeholder="Poder" v-model="modelexp.poder_ente_id">
              <el-option v-for="option in poderes" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
              </el-option>
            </el-select>
          </div>

        </div>
        <div class="row">
          <div class="col-md-12 form-group">
            <label class="control-label">
              Nombre de la Institución
            </label>
            <input class="form-control" type="text" name="nombreins" v-validate="modelExp.nombreins" v-model="modelexp.nombre_institucion" placeholder="Nombre de la institución" />
            <small class="text-danger" v-show="nombreins.invalid">
              {{ getError('nombreins') }}
            </small>
          </div>
          <div class="col-md-8 form-group">
            <label class="control-label">
              Unidad Administrativa/Área
            </label>
            <input class="form-control" type="text" name="unidadadm" v-validate="modelExp.unidadadm" v-model="modelexp.unidad_administrativa" placeholder="Nombre de la institución" />
            <small class="text-danger" v-show="unidadadm.invalid">
              {{ getError('unidadadm') }}
            </small>
          </div>
        </div>


        <domicilio v-model="n_domicilio2" titulo="/Ubicación del Cargo"></domicilio>
        <br><br>
        <div class="row">
          <div class="col-md-4">
            <label class="control-label">
              Sector/Industria:
            </label>
            <el-select clearable class="select-default" placeholder="Sector" name="sectorexp" v-validate="modelExp.sectorexp" v-model="modelexp.sector_industria_id">
              <el-option v-for="option in sectores" class="select-default" :value="option.id" :label="option.valor" :key="option.codigo">
              </el-option>
            </el-select>
            <small class="text-danger" v-show="sectorexp.invalid">
              {{ getError('sectorexp') }}
            </small>
          </div>

          <div class="col-md-8">
            <div class="form-group">
              <label class="control-label">
                Jerarquía/Rango
              </label>
              <input class="form-control" type="text" name="jerarqexp" v-validate="modelExp.jerarqexp" v-model="modelexp.jerarquia_rango" placeholder="Jerarquía/Rango" />
              <small class="text-danger" v-show="jerarqexp.invalid">
                {{ getError('jerarqexp') }}
              </small>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-md-8">
            <div class="form-group">
              <label class="control-label">
                Cargo/Puesto:
              </label>
              <input class="form-control" type="text" name="cargopuesto" v-validate="modelExp.cargopuesto" v-model="modelexp.cargo_puesto" placeholder="Cargo/Puesto" />
              <small class="text-danger" v-show="cargopuesto.invalid">
                {{ getError('cargopuesto') }}
              </small>
            </div>
          </div>
          <div class="col-md-4">
            <div class="form-group">
              <label class="control-label">
                Fecha de ingreso
              </label>
              <div class="form-group">
                <el-date-picker format="dd/MM/yyyy" name="fechaingreso" v-validate="modelExp.fechaingreso" v-model="modelexp.fecha_ingreso" type="date" placeholder="Fecha Ingreso">
                </el-date-picker>
              </div>
              <small class="text-danger" v-show="fechaingreso.invalid">
                {{ getError('fechaingreso') }}
              </small>
            </div>
          </div>
        </div>

        <div class="row">
          <div class="col-md-4">
            <div class="form-group">
              <label class="control-label">
                Fecha de salida
              </label>
              <div class="form-group">
                <el-date-picker v-model="modelexp.fecha_salida" type="date" format="dd/MM/yyyy" placeholder="Fecha Salida">
                </el-date-picker>
              </div>
            </div>
          </div>
          <div class="col-sm-6">
            <label class="control-label">
              Funciones Principales:
            </label>
            <el-select clearable multiple class="select-primary" v-model="modelexp.funcionesp" name="funcionespp" v-validate="modelExp.funcionesp" width="100%" placeholder="Funciones Principales">
              <el-option v-for="option in funciones" class="select-primary" :value="option.id" :label="option.valor" :key="option.codigo">
              </el-option>
            </el-select>
          </div>
        </div>

        <!--tabla para agregar y editar-->
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar
            </span>

            <span v-else>
              <i class="fa fa-save"></i> Guardar
            </span>
          </button>
          <button class="btn btn-danger ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i>
            </span>
          </button>
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar
            </span>
          </button>
        </div>

        <div class="row mt-3">
          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_exp" responsive hover :items="list_experiencia" :fields="fields_list">
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null">
                  Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null">
                  Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>

              <div slot="ambito_id" slot-scope="row" class="text-right">{{getAmbito(row.item.ambito_id)}}</div>
              <div slot="nivel_gobierno_id" slot-scope="row">{{getNivel(row.item.nivel_gobierno_id)}}</div>
              <div slot="poder_ente_id" slot-scope="row">{{getPoder(row.item.poder_ente_id)}}</div>
              <div slot="nombre_institucion" slot-scope="row">{{row.item.nombre_institucion}}</div>
              <div slot="unidad_administrativa" slot-scope="row">{{row.item.unidad_administrativa}}</div>
              <div slot="sector_industria_id" slot-scope="row">{{getSector(row.item.sector_industria_id)}}</div>
              <div slot="jerarquia_rango" slot-scope="row">{{row.item.jerarquia_rango}}</div>
              <div slot="cargo_puesto" slot-scope="row">{{row.item.cargo_puesto}}</div>
              <div slot="fecha_ingreso" slot-scope="row">{{row.item.fecha_ingreso}}</div>
              <div slot="fecha_salida" slot-scope="row">{{row.item.fecha_salida}}</div>
              <div slot="direccion_pais_id" slot-scope="row">{{getPais(row.item.direccion_pais_id)}}</div>
              <div slot="direccion_entidad_federativa_id" slot-scope="row">{{getEntidad(row.item.direccion_entidad_federativa_id)}}</div>
              <div slot="direccion_municipio_id" slot-scope="row">{{getMunicipio(row.item.direccion_municipio_id)}}</div>
              <div slot="direccion_cp" slot-scope="row">{{row.item.direccion_cp}}</div>
              <div slot="direccion_numext" slot-scope="row" class="text-right">{{row.item.direccion_numext}}</div>
              <div slot="direccion_numint" slot-scope="row">{{row.item.direccion_numint}}</div>
            </b-table>
          </div>
        </div>
      </div>
    </div>


  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker
  } from 'element-ui'


  import Domicilio from '../Domicilio.vue'

  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      Domicilio
    },

    data() {
      return {
        grupo: null,
        ip_id: null,
        datePicker: '',
        poderes: {},
        niveles: {},
        funcionesArr: [],
        funcionesExpArr: [],
        list_experiencia: [],
        edit_item: null,
        add_item: false,
        entidadFed: null,
        municipios: null,
        localidades: null,
        localidad: null,
        entes: {},
        ambitos: {},
        funciones: {},
        sectores: {},
        model: {},
        modelexp: {},
        n_domicilio: {},
        n_domicilio2: {},
        modelValidations: {
          correo_laboral: {
            email: true
          },
          ente: {
            required: true
          },
          nombre_cargo: {
            required: true
          },
          nivel: {
            required: true
          },
          poder: {
            required: true
          },
          honorarios: {
            required: true
          },
          nivel_orden: {
            required: true
          },
          area: {
            required: true
          },
          toma_posesion: {
            required: true
          },
          sector: {
            required: true
          },
          funciones_p: {
            required: true
          }
        },
        modelExp: {
          ambitoexp: {
            required: true
          },
          nombreins: {
            required: true
          },
          unidadadm: {
            required: true
          },
          jerarqexp: {
            required: true
          },
          cargopuesto: {
            required: true
          },
          fecha_ingreso: {
            required: true
          }
        },
        fields_list: [
          "acciones",
          {
            key: "ambito_id",
            label: "Ámbito",
            tdClass: "text-left"
          },
          {
            key: "nivel_gobierno_id",
            label: "Nivel",
            tdClass: "text-left"
          },
          {
            key: "poder_ente_id",
            label: "Poder Jurídico",
            tdClass: "text-left"
          },
          {
            key: "nombre_institucion",
            label: "Nombre",
            tdClass: "text-left"
          },
          {
            key: "unidad_administrativa",
            label: "Unidad",
            tdClass: "text-left"
          },
          {
            key: "sector_industria_id",
            label: "Sector/Industria",
            tdClass: "text-left"
          },
          {
            key: "jerarquia_rango",
            label: "Jerarquia",
            tdClass: "text-left"
          },
          {
            key: "cargo_puesto",
            label: "Cargo/Puesto",
            tdClass: "text-left"
          },
          {
            key: "fecha_ingreso",
            label: "Fecha Ingreso",
            tdClass: "text-left"
          },
          {
            key: "fecha_salida",
            label: "Fecha Salida",
            tdClass: "text-left"
          },
          {
            key: "direccion_pais_id",
            label: "País",
            tdClass: "text-left"
          },
          {
            key: "direccion_entidad_federativa_id",
            label: "Entidad Federativa",
            tdClass: "text-left"
          },
          {
            key: "direccion_municipio_id",
            label: "Municipio",
            tdClass: "text-left"
          },
          {
            key: "direccion_cp",
            label: "CP",
            tdClass: "text-left"
          },
          {
            key: "direccion_numext",
            label: "Num Ext",
            tdClass: "text-left"
          },
          {
            key: "direccion_numint",
            label: "Num Int",
            tdClass: "text-left"
          }
        ]
      }
    },
    created() {
      console.log(modelExp.ambito_id + "<");
      if (modelExp.ambito_id == '') {
        console.log('hola2');
        modelExp.ambito_id = 1;
      }
    },
    mounted() {

      this.grupo = this.getKey('grupo');
      this.ip_id = this.getId();
      this.getSectores();
      this.getPoderes();
      this.getNivelesG();
      this.getAmbitos();
      this.getFunciones();
      this.getInfLaboral();
      this.getExperiencia();
      this.getEntes();

      this.$http.get("entidadFed").then(
        response => {
          this.entidadFed = response.data.entidadfed;
        },
        error => {
          this.Err(error);
        }
      );

      this.$http.get("municipios").then(
        response => {
          this.municipios = response.data.municipios;
        },
        error => {
          this.Err(error);
        }
      );
      console.log(modelExp.ambito_id + "<--");
      if (modelExp.ambito_id == '') {
        console.log('hola');
        modelExp.ambito_id = 1;
      }
    },

    watch: {
      n_domicilio2: {
        handler: function () {
          if (this.n_domicilio2) {
            this.modelexp.direccion_pais_id = this.n_domicilio2.pais ? this.n_domicilio2.pais : 150;
            this.modelexp.direccion_entidad_federativa_id = this.n_domicilio2.entidadF ? this.n_domicilio2.entidadF : "";
            this.modelexp.direccion_municipio_id = this.n_domicilio2.municipio ? this.n_domicilio2.municipio : "";
            this.modelexp.direccion_localidad_id = this.n_domicilio2.localidad ? this.n_domicilio2.localidad : "";
            this.modelexp.direccion_cp = this.n_domicilio2.cp ? this.n_domicilio2.cp : "";
            this.modelexp.vialidad_nombre = this.n_domicilio2.vialidad_nombre ? this.n_domicilio2.vialidad_nombre : "";
            this.modelexp.tipo_vialidad = this.n_domicilio2.vialidad ? this.n_domicilio2.vialidad : "";
            this.modelexp.direccion_numext = this.n_domicilio2.ext ? this.n_domicilio2.ext : "";
            this.modelexp.direccion_numint = this.n_domicilio2.int ? this.n_domicilio2.int : "";
            this.modelexp.direccion_colonia = this.n_domicilio2.colonia ? this.n_domicilio2.colonia : "";
          }
        },
        deep: true
      },
      n_domicilio: {
        handler: function () {
          if (this.n_domicilio) {
            this.model.direccion_encargo_pais_id = this.n_domicilio.pais ? this.n_domicilio.pais : 150;
            this.model.direccion_encargo_entidad_federativa_id = this.n_domicilio.entidadF ? this.n_domicilio.entidadF : "";
            this.model.direccion_encargo_municipio_id = this.n_domicilio.municipio ? this.n_domicilio.municipio : "";
            this.model.direccion_encargo_localidad_id = this.n_domicilio.localidad ? this.n_domicilio.localidad : "";
            this.model.direccion_encargo_cp = this.n_domicilio.cp ? this.n_domicilio.cp : "";
            this.model.vialidad_nombre = this.n_domicilio.vialidad_nombre ? this.n_domicilio.vialidad_nombre : "";
            this.model.tipo_vialidad = this.n_domicilio.vialidad ? this.n_domicilio.vialidad : "";
            this.model.direccion_encargo_numext = this.n_domicilio.ext ? this.n_domicilio.ext : "";
            this.model.direccion_encargo_numint = this.n_domicilio.int ? this.n_domicilio.int : "";
            this.model.direccion_encargo_colonia = this.n_domicilio.colonia ? this.n_domicilio.colonia : "";
          }

        },
        deep: true
      }
    },
    methods: {
      getError(fieldName) {
        return this.errors.first(fieldName)
      },
      validate() {
        return this.$validator.validateAll()
      },
      showItem() {
        this.add_item = !this.add_item;
      },

      getMunicipio(index) {
        var resp = "";
        if (this.municipios) {
          this.municipios.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_mun;
              return resp;
            }
          });
        }
        return resp;
      },
      getAmbito(index) {
        var resp = "";
        if (this.ambitos) {
          this.ambitos.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getPoder(index) {
        var resp = "";
        if (this.poderes) {
          this.poderes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getNivel(index) {
        var resp = "";
        if (this.niveles) {
          this.niveles.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getSector(index) {
        var resp = "";
        if (this.sectores && index) {
          this.sectores.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getEntidad(index) {
        var resp = " ";
        if (this.entidadFed) {
          this.entidadFed.forEach(function (item) {
            if (item.id == index) {
              resp = item.nom_ent;
              return resp;
            }
          });
        }
        return resp;
      },
      getEnte(index) {
        var resp = " ";
        if (this.entes) {
          this.entes.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.limpiaCampos();
        this.showItem();
        this.edit_item = null;
      },
      getInfLaboral() {
        var v = this;
        this.$http.get('encargoAct/' + this.ip_id).then(
          response => {
            if (response.data.informacion != null) {

              this.model = response.data.informacion;
              this.model.contratado_honorarios = String(this.model.contratado_honorarios);

              ///para tomar solo el dato correspondiente a la funcion
              $.each(response.data.informacion.funcionesp, function (key, value) {
                v.funcionesArr.push(value.funcion_id);
              })
              this.model.funcionesp = v.funcionesArr;
            }

            this.n_domicilio = {
              'pais_id': this.model.direccion_encargo_pais_id,
              'entidadF': this.model.direccion_encargo_entidad_federativa_id,
              'municipio': this.model.direccion_encargo_municipio_id,
              'colonia': v.model.direccion_encargo_colonia,
              'cp': v.model.direccion_encargo_cp,
              'localidad': v.model.direccion_encargo_localidad_id,
              'ext': v.model.direccion_encargo_numext,
              'int': v.model.direccion_encargo_numint,
              'vialidad': v.getSafe(() => this.model.vialidad.tipo_vial) ? this.model.vialidad.tipo_vial : '',
              'vialidad_nombre': v.getSafe(() => this.model.vialidad.nom_vial) ? this.model.vialidad.nom_vial : ''
            }
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getExperiencia() {
        var v = this;
        this.$http.get('expLaboral/' + this.ip_id).then(
          response => {
            this.list_experiencia = response.data.experiencia;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getEntes() {
        var v = this;
        this.$http.get('cat_ente_publico').then(
          response => {
            this.entes = response.data.entes_publicos;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getSafe(fn, defaultVal) {
        try {
          return fn();
        } catch (e) {
          return defaultVal;
        }
      },
      addItem() {
        this.$validator.validateAll().then(
          response => {
            if (response) {
              this.loadButton(this.$refs.btnSave);
              this.$http.put('expLaboral/' + this.ip_id, this.modelexp).then(
                response => {
                  this.StepOk("Guardado");
                  /* this.origen_tramites = JSON.parse(JSON.stringify(response.data.tramite));
                  eventBus.$emit("TramiteSaved", response.data.tramite);
                  this.envioRespuesta(true); */
                  if (this.edit_item === undefined || this.edit_item === null) {
                    this.list_experiencia.push({
                      ...this.modelexp
                    });
                  } else {
                    this.list_experiencia.splice(
                      this.edit_item.index,
                      1,
                      this.modelexp
                    );
                    this.edit_item.item._rowVariant = "";
                  }

                  this.showItem();
                  this.limpiaCampos();
                  this.edit_item = null;
                },
                error => {
                  this.StepError(error);
                  //this.change =  true;
                }
              );
            } else {
              this.StepW("Hay campos sin completar");
            }
          }
        );
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.modelexp = {
          ...this.list_experiencia[this.edit_item.index]
        };
        var v = this;
        $.each(this.modelexp.funciones, function (key, value) {
          v.funcionesExpArr.push(value.funcion_id);
        })
        this.modelexp.funcionesp = v.funcionesExpArr;
        this.editDomicilio();
        this.edit_item.item._rowVariant = "warning";
        $(".main-panel").animate({
            scrollTop: 1300
          },
          500,
          "swing"
        );
      },
      removeItem(indice) {
        if (this.list_experiencia[indice].id !== null) {
          let item = this.list_experiencia[indice];
          this.list_experiencia.splice(indice, 1);
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("expLaboral/" + item.id).then(
              response => {
                /* eventBus.$emit("TramiteDelete", item); */
                this.list_experiencia.splice(indice, 1);
                this.OK("Registro eliminado");
              },
              error => {
                this.Err(error);
              }
            );
          });
        } else {
          this.Ask("Desea borrar este registro", () => {
            this.list_experiencia.splice(indice, 1);
          });
        }
      },
      limpiaCampos() {
        this.modelexp = {
          ambito_id: '',
          nivel_gobierno_id: '',
          poder_ente_id: '',
          nombre_institucion: '',
          unidad_administrativa: '',
          sector_industria_id: '',
          jerarquia_rango: '',
          cargo_puesto: '',
          fecha_ingreso: '',
          fecha_salida: '',
          funcionesp: ''
        };

        this.n_domicilio2 = {
          pais: 150,
          entidadF: '',
          municipio: '',
          localidad: '',
          cp: '',
          colonia: '',
          vialidad: '',
          vialidad_nombre: '',
          ext: '',
          int: ''
        };
      },
      editDomicilio() {

        this.n_domicilio2.pais = this.modelexp.direccion_pais_id;
        this.n_domicilio2.entidadF = this.modelexp.direccion_entidad_federativa_id;
        this.n_domicilio2.municipio = this.modelexp.direccion_municipio_id;
        this.n_domicilio2.localidad = this.modelexp.direccion_localidad_id;
        this.n_domicilio2.cp = this.modelexp.direccion_cp;
        this.n_domicilio2.colonia = this.modelexp.direccion_colonia;
        this.n_domicilio2.vialidad = this.modelexp.vialidad.tipo_vial;
        this.n_domicilio2.vialidad_nombre = this.modelexp.vialidad.nom_vial;
        this.n_domicilio2.ext = this.modelexp.direccion_numext;
        this.n_domicilio2.int = this.modelexp.direccion_numint;

      },
      showInput() {
        this.tags.inputVisible = true
        this.$nextTick(() => {
          this.$refs.saveTagInput.$refs.input.focus()
        })
      },
      handleInputConfirm() {
        let inputValue = this.tags.inputValue
        if (inputValue) {
          this.tags.dynamicTags.push(inputValue)
        }
        this.tags.inputVisible = false
        this.tags.inputValue = ''
      },
      getPoderes() {
        this.$http.get('poderJuridico').then(
          response => {
            this.poderes = response.data.poderJuridico;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getNivelesG() {
        this.$http.get('nivelGobierno').then(
          response => {
            this.niveles = response.data.nivelGobierno;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getAmbitos() {
        this.$http.get('ambitos').then(
          response => {
            this.ambitos = response.data.ambitos;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getSectores() {
        this.$http.get('cat_sector_industria').then(
          response => {
            this.sectores = response.data.sectores;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      },
      getFunciones() {
        this.$http.get('funcPrinc').then(
          response => {
            this.funciones = response.data.funciones;
          },
          error => {
            this.StepError(error);
            console.log(error);
          }
        )
      }
    }
  }

</script>
<style>


</style>
